moSetGetInputOutputFs = {};

function moSetGetInputOutputFs:getFs(self, objectTable, xmlModString)	
	local inputFillTypes={}
	local outputFillTypes={}
	local container = 1;
	local ratio = 0;	
	local setProduktivity = false;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local outputFull = false;
	local inputEmty = false;
	local capacity = 0;
	local fillLevel = 0;
	if objectTable ~= nil then
		if objectTable.Produkte ~= nil then
			setProduktivity = true;
			for _index,v in pairs (objectTable.Produkte) do
				local fillTypes = {};
				if objectTable.Produkte[_index].acceptedFillTypes ~= nil then
					fillTypes = objectTable.Produkte[_index].acceptedFillTypes;			
					for fillType,isAccepted in pairs(fillTypes) do			
						if(isAccepted)then				
							local alreadyInTable=false;
							if outputFillTypes[container] ~= nil then
								--inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+objectTable.Rohstoffe[_index].capacity;
								--inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+objectTable.Rohstoffe[_index].fillLevel;					
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, objectTable.Produkte[_index].name, outputFillTypes[container][1].fillTypeName, objectTable.Produkte[_index].nameL);
								if not string.find(outputFillTypes[container][1].fillTypeName, fillTypeNameString) then outputFillTypes[container][1].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes+1;end;
								outputFillTypes[container][1].fillTypeName = fillTypeNameString;
								alreadyInTable=true;													
							end;
							if(not alreadyInTable)then
								local info={};
								info.capacity = objectTable.Produkte[_index].capacity;
								info.fillLevel = objectTable.Produkte[_index].fillLevel;
								ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
								if tonumber(ratio) >= 100 then outputFull = true;end;								
								info.container = container;					
								info.fillTypeName = "";
								info.lengthFillTypes = 1;					
								outputFillTypes[container] = {};
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, objectTable.Produkte[_index].name, info.fillTypeName, objectTable.Produkte[_index].nameL);	--fillType				
								info.fillTypeName = fillTypeNameString;
								info.pricePerLiter = pricePerLiter;
								table.insert(outputFillTypes[container], info);					
							end;
						end;
					end;			
				end;
				container = container+1;
			end;
		end;		
		if objectTable.palSammler ~= nil then		
			for k, objectPal in pairs(objectTable.palSammler) do				
				local info = {};
				info.capacity = 0;
				info.fillLevel = 0;
				info.container = container;					
				info.fillTypeName = moLanguageXml:getTxt("palsammler", nil, "PalCollector");
				info.lengthFillTypes = 1;
				info.pricePerLiter = 0;
				info.setColor = moGuiMiniPdaSlots.warningColor0
				local objCreate = objectTable.palSammler[k];			
				local fremdObj = objCreate.fremdObject;
				if fremdObj ~= nil and fremdObj > 0 then info.fillTypeName = moLanguageXml:getTxt("palsammlerblocked", nil, "Blocked !!");end;
				info.capacity = Utils.getNoNil(table.getn(objCreate.Points), 1);
				local noticePal = 0;
				if info.capacity > 1 then
					for i = 1, info.capacity do
						if objCreate.Points[i].Pallet ~= nil then
							noticePal = noticePal+1;					
						end;
					end;
				end;			
				info.fillLevel = info.fillLevel+noticePal;			
				if info.fillLevel >= info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor4;end;
				if info.fillLevel >= info.capacity/2 and info.fillLevel < info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor2;end;			
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;
			end;
		end;
		container = 1;	
		if objectTable.Rohstoffe ~= nil then
			setProduktivity = true;
			for _index,v in pairs (objectTable.Rohstoffe) do
				local acceptedFillTypes = {};
				local info={};			
				info.capacity = objectTable.Rohstoffe[_index].capacity;
				info.fillLevel = objectTable.Rohstoffe[_index].fillLevel;
				--ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
				if info.fillLevel <= 0.1 then inputEmty = true;end;
				if not outputFull then
					if not inputEmty then
						capacity = capacity+info.capacity;
						fillLevel = fillLevel+info.fillLevel;
					end;
				end;				
				--if tonumber(productivity) >= tonumber(ratio) then
				--	productivity = tonumber(ratio);	
				--end;
				info.container = container;					
				info.fillTypeName = "";
				--local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, objectTable.Rohstoffe[_index].name, info.fillTypeName, objectTable.Rohstoffe[_index].nameL);
				info.lengthFillTypes = 0;
				info.pricePerLiter = 0;--pricePerLiter;
				--info.fillTypeName = fillTypeNameString;
				if objectTable.Rohstoffe[_index].acceptedFillTypes ~= nil then
					acceptedFillTypes = objectTable.Rohstoffe[_index].acceptedFillTypes;				
					for fillType,isAccepted in pairs(acceptedFillTypes) do			
						if(isAccepted)then				
							local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, Fillable.fillTypeIntToName[fillType], info.fillTypeName, objectTable.Rohstoffe[_index].nameL);
							if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
							--local alreadyInTable=false;
							--if inputFillTypes[container] ~= nil then
								--inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+objectTable.Rohstoffe[_index].capacity;
								--inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+objectTable.Rohstoffe[_index].fillLevel;					
							--	local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, objectTable.Rohstoffe[_index].name, inputFillTypes[container][1].fillTypeName, objectTable.Rohstoffe[_index].nameL);
							--	if not string.find(inputFillTypes[container][1].fillTypeName, fillTypeNameString) then inputFillTypes[container][1].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes+1;end;
							--	inputFillTypes[container][1].fillTypeName = fillTypeNameString;
							--	alreadyInTable=true;												
							--end;
							--if(not alreadyInTable)then
							--	local info={};
							--	info.capacity = objectTable.Rohstoffe[_index].capacity;
							--	info.fillLevel = objectTable.Rohstoffe[_index].fillLevel;
							--	info.container = container;					
							--	info.fillTypeName = "";
							--	info.lengthFillTypes = 1;					
							--	inputFillTypes[container] = {};
							--	local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, objectTable.Rohstoffe[_index].name, info.fillTypeName, objectTable.Rohstoffe[_index].nameL);					
							--	info.fillTypeName = fillTypeNameString;
							--	info.pricePerLiter = pricePerLiter;
							--	table.insert(inputFillTypes[container], info);					
							--end;
						end;
					end;			
				end;
				if string.len(info.fillTypeName) > 0 and info.lengthFillTypes == 0 then info.lengthFillTypes = 1;end;
				if string.len(info.fillTypeName) == 0 then 
					local pricePerLiter, fillTypeNameString = moSetGetInputOutputFs:getFillTypeStringName(self, objectTable.Rohstoffe[_index].name, info.fillTypeName, objectTable.Rohstoffe[_index].nameL);
					info.lengthFillTypes = 1;
					info.fillTypeName = fillTypeNameString;
				end;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container = container+1;
			end;
		end;
	end;
	if setProduktivity then		
		productivity = Utils.getNoNil(fillLevel/capacity*100, 0);
		if not outputFull and not inputEmty then
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;
		else
			if inputEmty then 
				productivity = 0;
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			else
				productivity = 50;
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			end;
		end;
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;	
	end;
	return inputFillTypes, outputFillTypes	
end;

function moSetGetInputOutputFs:getFillTypeStringName(self, name, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local fillTypeNamePal = "";
	local desc = Fillable.fillTypeNameToDesc[name]; --Fillable.fillTypeIndexToDesc[fillType];	--Fillable.fillTypeIndexToDesc[xmlModString.Rohstoffe[k1].name];
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		--if fillTypeName ~= nil and string.find(string.lower(fillTypeName), "pal") then fillTypeNamePal = "(pal)";end;
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. fillTypeName;									
			else
				stringName = fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;