moSetGetMapObjects = {};

function moSetGetMapObjects:searchFirstMapObjects(self)	
	moMapObjects = {};
	moMapObjects.fs = {};
	moMapObjects.sr = {};
	moMapObjects.ls = {};
	moMapObjects.vm = {};
	moMapObjects.upk = {};
	moMapObjects.other = {};
	moMapObjects.palSammler = {};
	moMapObjects.watermod = {};	
	--moMapShops = {};	
	moBgaMapObjects = {};
	moBgaMapObjects.silo = 0;
	moBgaMapObjects.catcher = 0;
	moBgaMapObjects.bgaExtension = false;
	moBgaMapObjects.silageExtension = false;	
	local fs = 0;
	local vm = 0;
	local ls = 0;
	local sr = 0;
	local upk = 0;
	local other = 0;
	local palSammler = 0;	
	if g_currentMission.onCreateLoadedObjects ~= nil then		
		for k, onCreateObject in pairs(g_currentMission.onCreateLoadedObjects) do
			if moGeneralSettings.upkReady and onCreateObject.base then
				upk = upk+1;
				local upkName = "factory";
				moMapObjects.upk[upk] = onCreateObject.base;
				local x,y,z = getWorldTranslation(onCreateObject.base.rootNode);
				moMapObjects.upk[upk].x = x;
				moMapObjects.upk[upk].z = z;
				if onCreateObject.base.name ~= nil then
					upkName = string.lower(onCreateObject.base.name);
				end;
				moMapObjects.upk[upk].name = upkName;
				moGeneralSettings.foundUpk = moGeneralSettings.foundUpk.. "MapName(xmlModString):".. tostring(upkName).. " ";
			end;
			if onCreateObject.fremdObject ~= nil and onCreateObject.Points ~= nil then				
				if onCreateObject.WoolPaletteCollectorDirtyFlag then
					moGeneralSettings.wollPalCollector = true;
					if onCreateObject.Points ~= nil and onCreateObject.Points[0] ~= nil and onCreateObject.Points[0].node2 ~= nil then
						palSammler = palSammler+1;
						moMapObjects.palSammler[palSammler] = onCreateObject;
						local x,y,z = getWorldTranslation(onCreateObject.Points[0].node2);
						moMapObjects.palSammler[palSammler].palX = tonumber(math.floor(x + .5));
						moMapObjects.palSammler[palSammler].palY = tonumber(math.floor(y + .5));
						moMapObjects.palSammler[palSammler].palZ = tonumber(math.floor(z + .5));
					
					end;										
				end;
				if onCreateObject.PalettenSammlerDirtyFlag then					
					if onCreateObject.palletSpawnerPlaceId ~= nil then						
						moGeneralSettings.palSammler = true;
						palSammler = palSammler+1;
						moMapObjects.palSammler[palSammler] = onCreateObject;
						local x,y,z = getWorldTranslation(onCreateObject.palletSpawnerPlaceId);																		
						moMapObjects.palSammler[palSammler].palX = tonumber(math.floor(x + .5));
						moMapObjects.palSammler[palSammler].palY = tonumber(math.floor(y + .5));
						moMapObjects.palSammler[palSammler].palZ = tonumber(math.floor(z + .5));						
					end;
				end;
			end;
			if not moGeneralSettings.watermod and onCreateObject.Needs ~= nil then				
				moGeneralSettings.watermod = true;
				--moMapObjects.watermod = onCreateObject.Needs
				for k, v in pairs(onCreateObject.Needs) do
					moMapObjects.watermod[k] = {};					
					local a = 0;
					for k1, v1 in pairs(onCreateObject.Needs[k]) do
						a = a+1;
						moMapObjects.watermod[k][a] = k1;						
					end;
					moMapObjects.watermod[k].length = a;					
				end;				
			end;			
			if onCreateObject.improvedSilageBunkerInitDone ~= nil and not moBgaMapObjects.silageExtension then
				moBgaMapObjects.silageExtension = true;								
			end;			
			if onCreateObject.FabrikScriptDirtyFlag or onCreateObject.name ~= nil then
				if onCreateObject.name and not onCreateObject.FabrikScriptDirtyFlag then
					local otherName = string.lower(string.gsub(onCreateObject.name, " ", ""));
					if string.find(moObjectsDefault.acceptOther, otherName.. " ") then
						other = other+1;
						moGeneralSettings.foundOther = moGeneralSettings.foundOther.. tostring(otherName).. " ";
						moMapObjects.other[other] = onCreateObject;
						moMapObjects.other[other].name = otherName;
						if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
							local x,y,z = getWorldTranslation(onCreateObject.nodeId);
							moMapObjects.other[other].x = x;
							moMapObjects.other[other].z = z;
						end;
					end;					
				else
					moGeneralSettings.fabrikscript = true;
					fs = fs+1;
					moMapObjects.fs[fs] = onCreateObject;
					local x,y,z = getWorldTranslation(onCreateObject.nodeId);
					moMapObjects.fs[fs].x = x;
					moMapObjects.fs[fs].z = z;					
					local otherName = "factory";					
					if onCreateObject.Produkte ~= nil then
						local a = 0;
						for k, v in pairs(onCreateObject.Produkte) do
							if onCreateObject.Produkte[k] ~= nil and onCreateObject.Produkte[k].palletSpawner ~= nil and onCreateObject.Produkte[k].palletSpawner.SpawnerPlaceId ~= nil then									
								a = a+1;
								local palX,palY,palZ = getWorldTranslation(onCreateObject.Produkte[k].palletSpawner.SpawnerPlaceId);									
								if moMapObjects.fs[fs].palXYZ == nil then moMapObjects.fs[fs].palXYZ = {};end;
								moMapObjects.fs[fs].palXYZ[a] = {tonumber(math.floor(palX + .5)), tonumber(math.floor(palY + .5)), tonumber(math.floor(palZ + .5))};
								--moMapObjects.fs[fs].palX[a] = {tonumber(math.floor(palX + .5))};
								--moMapObjects.fs[fs].palY[a] = {tonumber(math.floor(palY + .5))};
								--moMapObjects.fs[fs].palZ[a] = {tonumber(math.floor(palZ + .5))};
							end;
						end;
					end;						
					if onCreateObject.StoffeIdToName ~= nil then
						--local stoffid = "";
						--for k, v in pairs(onCreateObject.StoffeIdToName) do
						--	stoffid = stoffid.. string.lower(v).. " ";
						--end;
						--if string.find(stoffid, "boardwood") then otherName = "saegewerk";end;						
						--if string.find(stoffid, "washedpotato") and not string.find(stoffid, "steamedpotato") then otherName = "potatowasher";end;
						--if string.find(stoffid, "steamedpotato") and string.find(stoffid, "washedpotato") then otherName = "potatosteamer";end;
						--if string.find(stoffid, "chicken2") and string.find(stoffid, "egg") then otherName = "egglayingstation";end;
						--if string.find(stoffid, "pigforage") then otherName = "pigforagemaster";end;
						--if string.find(stoffid, "lettuce") then otherName = "lettuce_greenhouse";end;
						--if string.find(stoffid, "strawberry") then otherName = "strawberry_greenhouse";end;
						--if string.find(stoffid, "raspberry") then otherName = "raspberry_greenhouse";end;
						--if string.find(stoffid, "blumenkohl") then otherName = "blumenkohl_greenhouse";end;
						--if string.find(stoffid, "tomate") then otherName = "tomate_greenhouse";end;
						--if string.find(stoffid, "weisskohl") then otherName = "weisskohl_greenhouse";end;
						--if string.find(stoffid, "chickenfeed") then otherName = "biofutter_factory";end;
						--if string.find(stoffid, "hmilk") then otherName = "milkmax";end;
					end;										
					moMapObjects.fs[fs].name = otherName;					
					if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
						local mapFactoryName = getUserAttribute(onCreateObject.nodeId, "factoryName"); --factoryName
						if mapFactoryName ~= nil and mapFactoryName ~= false then
							moMapObjects.fs[fs].name = mapFactoryName;
							if otherName == "factory" then otherName = "factory(Slot other1 - MapName(xmlModString):".. mapFactoryName.. ")";end;						
						end;					
					end;
					if otherName == "factory" then otherName = "factory(Slot other1)";end;
					moGeneralSettings.foundFabrikscript = moGeneralSettings.foundFabrikscript.. tostring(otherName).. " ";
				end;				
			end;			
			--if onCreateObject.FabrikScriptDirtyFlag ~= nil and not foundName then				
				--fs = fs+1;
				--moGeneralSettings.fabrikscript = true;
				--moDefaultPlaceableObjects.mapObjectsFsSearch = moDefaultPlaceableObjects.mapObjectsFsSearch+1;
				--moDefaultPlaceableObjects.mapObjectsFsStatus[fs] = onCreateObject;
				--moDefaultPlaceableObjects.mapObjectsFsName[fs] = unpack(moLanguage.extern["fabrik".. moDefault.language]).. "_".. fs;
				--moDefaultPlaceableObjects.mapObjectsFsAttributName[fs] = unpack(moLanguage.extern["fabrik".. moDefault.language]).. "_".. fs;
				--local modName = getUserAttribute(onCreateObject.nodeId, "onCreate"); --factoryName
				--if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
				--	local factoryName = Utils.getNoNil(getUserAttribute(onCreateObject.nodeId, "factoryName"), false); --factoryName				
				--	if factoryName ~= nil and factoryName ~= false then
				--		moDefaultPlaceableObjects.mapObjectsFsName[fs] = string.lower(factoryName);	
				--		moDefaultPlaceableObjects.mapObjectsFsAttributName[fs] = factoryName;						
				--	end;
				--end;
			--end;
			if onCreateObject.gasTriggerDirtyFlag ~= nil then
				moGeneralSettings.gasStation = true;			
			end;
			if onCreateObject.FermentingSiloDirtyFlag ~= nil then
				moGeneralSettings.fermentingSilo = true;
			end;
			if onCreateObject.siloTriggerfillDoneDirtyFlag ~= nil then
				moGeneralSettings.allInOnSilo = true;				
			end;			
			if onCreateObject.stationName == "BunkerSilo" and onCreateObject.bunkerSilo then				
				moBgaMapObjects.silo = moBgaMapObjects.silo+1
				moBgaMapObjects["silo".. moBgaMapObjects.silo] = {};
				moBgaMapObjects["silo".. moBgaMapObjects.silo].obj = onCreateObject.bunkerSilo;
				moBgaMapObjects["silo".. moBgaMapObjects.silo].objCreate = onCreateObject;
				if getUserAttribute ~= nil and onCreateObject.bunkerSilo.nodeId ~= nil then
					local silageSiloName = Utils.getNoNil(getUserAttribute(onCreateObject.bunkerSilo.nodeId, "silageSiloName"), nil); --factoryName
					if silageSiloName ~= nil then
						moBgaMapObjects["silo".. moBgaMapObjects.silo].siloName = silageSiloName;
					end;
				end;
			end;
			if onCreateObject.bunkerUseTime and onCreateObject.bunkerFillLevel then
				moBgaMapObjects.catcher = moBgaMapObjects.catcher+1;
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher] = {};
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].bgaExtension = false;
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].obj = onCreateObject.tipTriggers[1]; --g_currentMission.onCreateLoadedObjects[onCreateObject.id];
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].objCreate = onCreateObject;								
				if onCreateObject.fermenter_TS_clog or onCreateObject.BGA_Bonus ~= nil then					
					moBgaMapObjects["catcher".. moBgaMapObjects.catcher].bgaExtension = true;
					moBgaMapObjects.bgaExtension = true;					
				end;								
			end;
			--if onCreateObject.SchweineZuchtDirtyFlag1 ~= nil and onCreateObject.animal ~= nil then
			--	sr = sr+1;
			--	local animalName = string.lower(onCreateObject.animal);
			--	moMapObjects.sr[sr] = onCreateObject;
			--	moMapObjects.sr[sr].name = animalName;
			--	local x,y,z = getWorldTranslation(onCreateObject.tipTriggers[1].rootNode);
			--	moMapObjects.sr[sr].x = x;
			--	moMapObjects.sr[sr].z = z;				
			--	moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
			--	if g_currentMission.husbandries[animalName] ~= nil and g_currentMission.husbandries[animalName].palletSpawnerTriggerId ~= nil then
			--		local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[animalName].palletSpawnerTriggerId);																		
			--		moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
			--		moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
			--		moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
			--	end;
			--end;
			--if onCreateObject.HaseZuchtDirtyFlag1 ~= nil and onCreateObject.animal ~= nil then
			--	sr = sr+1;
			--	local animalName = string.lower(onCreateObject.animal);
			--	moMapObjects.sr[sr] = onCreateObject;
			--	moMapObjects.sr[sr].name = animalName;				
			--	local x,y,z = getWorldTranslation(onCreateObject.tipTriggers[1].rootNode);
			--	moMapObjects.sr[sr].x = x;
			--	moMapObjects.sr[sr].z = z;				
			--	moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
			--	if g_currentMission.husbandries[animalName] ~= nil and g_currentMission.husbandries[animalName].palletSpawnerTriggerId ~= nil then
			--		local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[animalName].palletSpawnerTriggerId);																		
			--		moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
			--		moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
			--		moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
			--	end;
			--end;
			--if onCreateObject.LammZuchtDirtyFlag1 ~= nil and onCreateObject.animal ~= nil then
			--	sr = sr+1;
			--	local animalName = string.lower(onCreateObject.animal);
			--	moMapObjects.sr[sr] = onCreateObject;
			--	moMapObjects.sr[sr].name = animalName;				
			--	local x,y,z = getWorldTranslation(onCreateObject.tipTriggers[1].rootNode);
			--	moMapObjects.sr[sr].x = x;
			--	moMapObjects.sr[sr].z = z;				
			--	moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
			--	if g_currentMission.husbandries[animalName] ~= nil and g_currentMission.husbandries[animalName].palletSpawnerTriggerId ~= nil then
			--		local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[animalName].palletSpawnerTriggerId);																		
			--		moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
			--		moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
			--		moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
			--	end;
			--end;
			if onCreateObject.ViehMarktDirtyFlag ~= nil then				
				if (onCreateObject.fillTypes ~= nil and onCreateObject.priceMultipliers ~= nil) then --old Version Viehmarkt					
					moGeneralSettings.viehmarkt = true;
					vm = vm+1;
					moMapObjects.vm[vm] = onCreateObject;
				elseif (onCreateObject.AnimalTrigger.fillTypes ~= nil and onCreateObject.AnimalTrigger.priceMultipliers ~= nil) then --new Version Viehmarkt
					moGeneralSettings.viehmarkt = true;
					vm = vm+1;
					moMapObjects.vm[vm] = onCreateObject.AnimalTrigger;					
				end;
				if moGeneralSettings.viehmarkt then			
					local x,y,z = getWorldTranslation(onCreateObject.AnimalTrigger.rootNode);
					moMapObjects.vm[vm].x = x;
					moMapObjects.vm[vm].z = z;					
				end;
			end;			
			if onCreateObject.mixFeederDirtyFlag then
				other = other+1;
				moGeneralSettings.foundOther = moGeneralSettings.foundOther.. tostring("mixfeeder ");
				moMapObjects.other[other] = onCreateObject;
				moMapObjects.other[other].name = "mixfeeder";
				if onCreateObject.nodeId ~= nil and getWorldTranslation ~= nil then
					local x,y,z = getWorldTranslation(onCreateObject.nodeId);
					moMapObjects.other[other].x = x;
					moMapObjects.other[other].z = z;
				end;
			end;					
		end;
	end;
	if g_currentMission.husbandries ~= nil then
		for k, v in pairs(g_currentMission.husbandries) do
			if tostring(k) == "sheep" or tostring(k) == "cow" or tostring(k) == "chicken" then				
				ls = ls+1;
				moMapObjects.ls[ls] = v;				
				local x,y,z;				
				if tostring(k) ~= "chicken" then x,y,z = getWorldTranslation(g_currentMission.husbandries[k].tipTriggers[1].rootNode);moMapObjects.ls[ls].x=x;moMapObjects.ls[ls].z=z;end;				
				local animalName = string.lower(k)
				if g_currentMission.husbandries[k] ~= nil and g_currentMission.husbandries[k].palletSpawnerTriggerId ~= nil then
					local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[k].palletSpawnerTriggerId);																		
					moMapObjects.ls[ls].palX = tonumber(math.floor(palX + .5));
					moMapObjects.ls[ls].palY = tonumber(math.floor(palY + .5));
					moMapObjects.ls[ls].palZ = tonumber(math.floor(palZ + .5));					
				end;				
				moMapObjects.ls[ls].name = animalName;
				moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";				
			elseif v.animal ~= nil then
				sr = sr+1;
				local animalName = string.lower(v.animal);
				moMapObjects.sr[sr] = v;
				moMapObjects.sr[sr].name = animalName;
				local x,y,z = getWorldTranslation(v.tipTriggers[1].rootNode);
				moMapObjects.sr[sr].x = x;
				moMapObjects.sr[sr].z = z;				
				moGeneralSettings.foundAnimals = moGeneralSettings.foundAnimals.. tostring(animalName).. " ";
				if g_currentMission.husbandries[animalName] ~= nil and g_currentMission.husbandries[animalName].palletSpawnerTriggerId ~= nil then
					local palX,palY,palZ = getWorldTranslation(g_currentMission.husbandries[animalName].palletSpawnerTriggerId);																		
					moMapObjects.sr[sr].palX = tonumber(math.floor(palX + .5));
					moMapObjects.sr[sr].palY = tonumber(math.floor(palY + .5));
					moMapObjects.sr[sr].palZ = tonumber(math.floor(palZ + .5));					
				end;
			end;
		end;
	end;
	local notFoundPalSammler = 0;
	if table.getn(moMapObjects.palSammler) > 0 then
		local foundPalSammler = 0;
		function checkSetPalSammler(mapObjectTable, mx, my, mz, k1)
			for k, palSammler in pairs(moMapObjects.palSammler) do
				if k ~= nil and palSammler.palX ~= nil and palSammler.palY ~= nil and palSammler.palZ ~= nil then
					local px = palSammler.palX;
					local py = palSammler.palY;
					local pz = palSammler.palZ;
					local distance = Utils.vector3Length(px-mx, py-my, pz-mz);
					if mx == px and my == py or distance <= 2 then --and mz == pz then
						if mapObjectTable.palSammler == nil then mapObjectTable.palSammler = {};end;
						mapObjectTable.palSammler[k1] = palSammler						
						foundPalSammler = foundPalSammler+1;
						break;						
					end;
				end;
			end;		
		end;
		if table.getn(moMapObjects.fs) > 0 and foundPalSammler < palSammler then
			for k, mapObject in pairs(moMapObjects.fs) do				
				if k ~= nil and mapObject.palXYZ ~= nil then
					for k1, mapObjectPal in pairs(mapObject.palXYZ) do
						if mapObjectPal ~= nil then
							local mx = mapObjectPal[1];
							local my = mapObjectPal[2];
							local mz = mapObjectPal[3];
							checkSetPalSammler(moMapObjects.fs[k], mx, my, mz, k1);
						end;
					end;
					if foundPalSammler >= palSammler then break;end;
				end;
			end;
		end;
		if table.getn(moMapObjects.sr) > 0 and foundPalSammler < palSammler then
			for k, mapObject in pairs(moMapObjects.sr) do				
				if k ~= nil and mapObject.palX ~= nil and mapObject.palY ~= nil and mapObject.palZ ~= nil then
					local mx = mapObject.palX;
					local my = mapObject.palY;
					local mz = mapObject.palZ;
					checkSetPalSammler(moMapObjects.sr[k], mx, my, mz, 1);
					if foundPalSammler >= palSammler then break;end;
				end;
			end;
		end;
		if table.getn(moMapObjects.ls) > 0 then --and foundPalSammler < table.getn(moMapObjects.palSammler) then
			for k, mapObject in pairs(moMapObjects.ls) do				
				if k ~= nil and mapObject.palX ~= nil and mapObject.palY ~= nil and mapObject.palZ ~= nil then
					local mx = mapObject.palX;
					local my = mapObject.palY;
					local mz = mapObject.palZ;
					checkSetPalSammler(moMapObjects.ls[k], mx, my, mz, 1);
					if foundPalSammler >= palSammler then break;end;
				end;
			end;
		end;
		if foundPalSammler < palSammler then
			moGeneralSettings.notFoundPalSammler = palSammler-foundPalSammler;
		end;
	end;
	table.remove(moMapObjects.palSammler);
	if moGeneralSettings.wollPalCollector then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("wollPalCollector").. " ";end;
	if moGeneralSettings.palSammler then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("palSammler(").. tostring(palSammler).. ") ";end;
	if moGeneralSettings.watermod then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("watermod").. " ";end;
	if moGeneralSettings.viehmarkt then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("viehmarkt").. " ";end;
	if moGeneralSettings.gasStation then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("gasStation").. " ";end;
	if moGeneralSettings.allInOnSilo then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("allInOnSilo").. " ";end;
	if moGeneralSettings.fermentingSilo then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("fermentingSilo").. " ";end;
	if moGeneralSettings.upkReady then moGeneralSettings.foundScripts = moGeneralSettings.foundScripts.. tostring("upk_universalProcessKit").. " ";end;	
end;